////////////////////////////////////////////////////////////////////////////////
//Copyright (c) 2007
//	Adam Sarzyski
//	adamusx@tlen.pl
//  adam@wobit.com.pl
////////////////////////////////////////////////////////////////////////////////

// ====== SONAR V2 ==============================
// Przyklad obslugi sonarow przez szyne I2C 
// Sonar (Sonary) nalezy podlaczyc do wyprowadzen SDA i SDC mikrokontrolera 
//(dla ATmegi 128:  SCL - PD0 (25), SDA - PD1 (26) ) . SDA i SCL nalezy podciagnac
// rezystorami (2K2 do 10K) do + zasilania. 

// Mikrokontroler: ATmega128
// Zegar: wewnetrzny oscylator 8MHz
// UART: UART0, 57600bps

// Kompilator GCC (WinAVR) ver 3.4.3


#include "Main.h"

#define INTERPRETER


// Adresy Sonarow
#define SONAR_1  0x01
#define SONAR_2  0x02
#define SONAR_3  0x03
#define SONAR_4  0x04
#define SONAR_5  0x05
#define SONAR_6  0x06
#define SONAR_7  0x07
#define SONAR_8  0x08



unsigned char buf[16];
////////////////////////////////////////////////////////////////////////////////
//Inicjalizacja wejsc/wyjsc 
////////////////////////////////////////////////////////////////////////////////
void ioinit(void)
{
DDRA=0x00;
DDRB=0xff;
DDRC=0xff;
DDRD|=(1<<4)|(1<<5)|(1<<6)|(1<<7);			
DDRF=0x00;
DDRE=0x00;

}

////////////////////////////////////////////////////////////////////////////////
//Funkcja gowna 
////////////////////////////////////////////////////////////////////////////////
int main(void)
{
    
UART_init();                        // Inicjalizacja UARTa                                                  
sei();								// Uruchomienie systemu przerwan

ioinit();							// Inicjalizacja wejsc/wyjsc

TWI_Master_Initialise();			// Inicjalizacja I2C


////////////////////////////////////////////////////////////////////////////////
//Petla nieskonczona
////////////////////////////////////////////////////////////////////////////////

UART_print("=====  Sonar v2 TEST ===== \n\r");
UART_print("======= WObit 2007 ======= \n\r");
UART_print("\n\r");

help();



for(;;)
{
       
       
   if(UART_data_in_rx_buffer());
	{
		UART_gets(buf,32);			   //odczytaj polecenia z rsa
		interpreter(buf);
	}


    /*
	// Tutaj mozna umiescic glowny kod programu 	
	sonar_request(SONAR_1);			// Wykonanie pomiaru przez Sonar 1 (wzmocnienie 29)
	sonar_request(SONAR_2);			// Wykonanie pomiaru przez Sonar 2 (wzmocnienie 29)
	
	_delay_ms(10);						   // Miedzy wykonaniem pomiaru przez Sonar a odczytaniem wyniku musi byc 
	_delay_ms(10);						   // Conajmniej 30ms przerwy. Wynika to z tego ze donyslnie  timeout sonara jest ustawiony na 
	_delay_ms(10);						   // dystans maks 5m (10m z powrotem echa). Dystans ten dzwiek pokonuje w  okoo 30ms. 

										   // Dla trybu auto czas ten powinien by jeszcze wiekszy 
										   // i wynosic conajmniej 200ms 
	
    dystans_sonar_1= sonar_gets_distance(SONAR_1);		// Odczytanie pomiaru Sonara 1 
    //dystans_sonar_2= sonar_gets_distance(SONAR_2);		// Odczytanie pomiaru Sonara 2
	
	itoa(dystans_sonar_1,buf,10);
    
    UART_print(buf);
    UART_print("\r\n");
	_delay_ms(1);
	*/
	
		
}
return 0;
}


////////////////////////////////////////////////////////////////////////////////
// Funkcja interpretacji komend
////////////////////////////////////////////////////////////////////////////////
void interpreter(unsigned char *cmd)
{

     unsigned char  sonar_nr;
     // Rozkazy zmiany parametrow i inne zaczynajace sie od 
	if(*(cmd)=='!')
	{
		switch(*(cmd+1)){
                         
 	        case 'p':        
                 help();
			break;      
                   
			case 'm':        
              sonar_nr =  atoi(cmd+2);         
              sonar_request(sonar_nr);     
			break;
			
			case 'r':        
                sonar_nr =  atoi(cmd+2); 
                dystans_sonar_1 = sonar_gets_distance(sonar_nr);		// Odczytanie pomiaru Sonara 1 
                UART_print("\r\n");
                itoa(dystans_sonar_1,buf,10);
                UART_print(buf);
                UART_print("\r\n");           
			break;

			case 'a':	   
			  sonar_nr =  atoi(cmd+2);
               while(!UART_data_in_rx_buffer())
               {  
                _delay_ms(1);                                                            
                sonar_request(sonar_nr);			// Wykonanie pomiaru przez Sonar 1 (wzmocnienie 29) 
			    	_delay_ms(20);
			    	_delay_ms(10);
    	        dystans_sonar_1 = sonar_gets_distance(sonar_nr);		// Odczytanie pomiaru Sonara 1 
                itoa(dystans_sonar_1,buf,10);
                
                UART_print("Odleglosc: ");
                UART_print(buf);
                UART_print("\r\n");    
                }  
			break;
			case 'd':
                 sonar_nr =  atoi(cmd+2);
                 UART_print("Podaj zasieg maksymaly [mm]: ");
  	             UART_gets(buf,5);			   //odczytaj polecenia z rsa
  	             UART_print("\r\n");
			     sonar_set_max_distance( atoi(buf), sonar_nr);
			break;
			
			case 's':
			     sonar_nr =  atoi(cmd+2);
			     UART_print("Podaj czulosc od -20(min) do 20 (max): ");
  	             UART_gets(buf,4);			   //odczytaj polecenia z rsa
  	             UART_print("\r\n");
                 sonar_set_sense(atoi(buf),sonar_nr);
                 //sonar_set_sense(35,sonar_nr);
			break;
			case 't':
                 sonar_nr =  atoi(cmd+2);
                 UART_print("Podaj prog wyjscia OUT [mm]: ");
  	             UART_gets(buf,4);			   //odczytaj polecenia z rsa
  	             UART_print("\r\n");
                 sonar_set_treshold_level(atoi(buf),sonar_nr);
		    break;
		    
	    	case 'l':
                 sonar_nr =  atoi(cmd+2);
                 sonar_sleep(sonar_nr);
		    break;
	    	
            case 'e':
                 sonar_nr =  atoi(cmd+2);
                 UART_print("Auto Sleep ON (1) OFF (0): ");
  	             UART_gets(buf,3);			   //odczytaj polecenia z rsa
  	             UART_print("\r\n");
                 sonar_auto_sleep(atoi(buf),sonar_nr);
		    break;

		}

	}

	

}

void help(void)
{  
    UART_print("Lista dostepnych rozkazow:\n\r");
    UART_print("!p  - pomoc\n\r");
    UART_print("!mX - wykonanie pomiaru, X- adres sonaru\n\r");
    UART_print("!rX - odebranie pomiaru, X- adres sonaru\n\r");
    UART_print("!aX - pomiar ciagly ( dopuki nie wyslany zostanie\n\r");
    UART_print(" jakikolwiek znak przez terminal), X- adres sonaru\n\r"); 
    UART_print("!dX - ustawienie zasiegu maksymalnego\n\r");  
    UART_print("!sX - ustawienie czulosci\n\r");   
    UART_print("!tX - ustawienie progu wyjscia OUT\n\r");
    UART_print("!lX - tryb uspienia OUT\n\r");
    UART_print("!eX - tryb uspienia auto OUT\n\r");
}

